#!/usr/bin/env python
# _*_ coding: utf-8 _*_
import pygame
import random
import sys
#-----------------------------------------------------------------------
# Функция создания изображения, аргументом является рисунок курсора
# или текст завершения игры
def sh(cur):
	i = 0
	while i < 16:
		x = (i - 4 * int(i / 4)) * 50
		y = 50 * int(i / 4)
		screen.blit(mp[i], (x, y))
		i += 1
	if cur <> tex:
		x, y = pygame.mouse.get_pos()
		x -= 16
		y -= 16
	else:
		x = 9
		y = 90
	screen.blit(cur, (x, y))
	pygame.display.update()
#-----------------------------------------------------------------------
def nfi():
	x, y = pygame.mouse.get_pos()
	x = int(x / 50) - (pusto - 4 * int(pusto / 4))
	y = int(y / 50) - int(pusto / 4)
	return x, y
#-----------------------------------------------------------------------
pygame.init()
screen = pygame.display.set_mode((200, 200))
mp = [] # список рисунков фишек
mn = range(16) # список номеров фишек
for i in mn: # заполнение списка рисунков
	mp.append(pygame.image.load('pict/' + str(i) + '.bmp'))
u = pygame.image.load('pict/U.bmp') # курсор 'вверх'
d = pygame.image.load('pict/D.bmp') # курсор 'вниз'
l = pygame.image.load('pict/L.bmp') # курсор 'лево'
r = pygame.image.load('pict/R.bmp') # курсор 'право'
s = pygame.image.load('pict/S.bmp') # курсор 'нет хода'
pygame.display.set_icon(r)
# Создание надписи окончания игры
fon = pygame.font.Font(None, 30)
tex = fon.render('Click to play again', True, (30, 198, 224), (0, 0, 0))
ct = 0 # начальное значение времени игры
#-----------------Основной цикл-----------------------------------------
while True:
	pygame.mouse.set_visible(False)
	i = 0
	while i < 50: # перемешивание фишек
		a = random.randrange(16)
		mp[0],mp[a] = mp[a],mp[0]
		mn[0],mn[a] = mn[a],mn[0]
		i += 1
	i = 0
	while i < 16: # определение номера пустой фишки
		if mn[i] == 0: pusto = i
		i += 1
	running = True
	while running:
		# --------Отображение времени игры в заголовке окна-------------
		sek = int((pygame.time.get_ticks() - ct) / 1000)
		min = int(sek / 60)
		sek = (sek - min * 60)
		k = '0' + str(sek)
		c = '0' + str(min)
		c = 'Time: ' + c[len(c) - 2 : ] + ':' + k[len(k) - 2 : ]
		pygame.display.set_caption(c)
		# --------------------------------------------------------------
		event = pygame.event.poll()
		if event.type == pygame.QUIT:
			sys.exit() # выход из программы
		elif event.type == pygame.KEYDOWN:
			running = False # при нажатии клавиши на клавиатуре - начало новой игры
		elif event.type == pygame.MOUSEBUTTONDOWN and cu <> s:
			# перемешение фишек
			if cu == u:
				loo = ys
				sm = 4
			if cu == d:
				loo = -1 * ys
				sm = -4
			if cu == l:
				loo = xs
				sm = 1
			if cu == r:
				loo = -1 * xs
				sm = -1
			i = 0
			while i < loo:
				q = pusto + sm
				mp[q],mp[pusto] = mp[pusto],mp[q]
				mn[q],mn[pusto] = mn[pusto],mn[q]
				q, pusto = pusto, q
				i += 1
		else: # определение рисунка курсора cu
			xs, ys = pygame.mouse.get_pos()
			xs = int(xs / 50) - (pusto - 4 * int(pusto / 4))
			ys = int(ys / 50) - int(pusto / 4)
			cu = s
			if ys >= 1 and xs == 0: cu = u
			if ys <= -1 and xs == 0: cu = d
			if ys == 0 and xs >= 1: cu = l
			if ys == 0 and xs <= -1: cu = r
			sh(cu)
		i = 0
		while i < 15: # проверка выигрыша
			if mn[i] <> i + 1: break
			i += 1
		if i >= 15: running = False
# ----------------------------------------------------------------------
	sh(tex)
	pygame.mouse.set_visible(True)
	running = True
	while running:
		event = pygame.event.wait()
		if event.type == pygame.MOUSEBUTTONDOWN:
			running = False
			ct = pygame.time.get_ticks()
		if event.type == pygame.QUIT: sys.exit()
